import static gdbutil.ConnectionParameters.*;

import java.io.*;
import java.sql.*;

/**
 * Klasse, um Oracle-BLOBs zu lesen und in Dateien zu speichern.
 * Ausfhrung bentigt ojdbc14.jar.
 *
 * @author: Thomas Brinkhoff, http://www.geodbs.de/
 */
public class ReadRasterFromBlob {

public static void main (String[] args) {
	try {
		// Verbindung zur Datenbank aufbauen
		Class.forName("oracle.jdbc.driver.OracleDriver");
		String url = "jdbc:oracle:thin:@" + DBHOST + ":" + DBPORT + ":" + DBNAME;  // JDBC Thin Driver
			// bei JDBC OCI Driver:  "jdbc:oracle:oci:@" + DBSERVICENAME;
		Connection db = DriverManager.getConnection(url, DBUSER, DBPASSWORD);

		// Datenstze abfragen
		Statement query = db.createStatement();
		ResultSet res = query.executeQuery("SELECT name,karte FROM Rasterkarten "+
				"WHERE SDO_FILTER(georef, MDSYS.SDO_GEOMETRY(2003,82027,null,"+
                "  MDSYS.SDO_ELEM_INFO_ARRAY(1,1003,3),"+
                "  MDSYS.SDO_ORDINATE_ARRAY(337000,5700000,3600000,6000000)),'querytype=WINDOW') = 'TRUE'");
		// Daten bertragen
		while (res.next()) {
			Blob blob = res.getBlob("karte");
			FileOutputStream outStream = new FileOutputStream(res.getString("name"));
			int len = (int)blob.length();
			byte[] buffer = blob.getBytes(1,len);
			outStream.write(buffer);
			outStream.close();
		}
		res.close();
		// Anweisung und Verbindung schlieen
		query.close();
		db.close();
	}
	// Fehler behandeln
	catch (Exception ex) {
		System.err.println("ReadRasterFromBlob.main: " + ex);
		ex.printStackTrace();
	}
}
}
